=== debian/changelog ===
liblol (0.1.6-1deepin1) unstable; urgency=medium

  * Build with GCC 12.

 -- Mingcong Bai <baimingcong@uniontech.com>  Fri, 17 Jan 2025 10:49:59 +0800

liblol (0.1.6-1) unstable; urgency=medium

  * Release 0.1.6-1

 -- Miao Wang <shankerwangmiao@gmail.com>  Mon, 16 Sep 2024 22:18:00 +0800

liblol (0.1.6~pre2-1) unstable; urgency=medium

  * Release 0.1.6~pre2-1
  * fix implementation of lxstat64

 -- Miao Wang <shankerwangmiao@gmail.com>  Sat, 31 Aug 2024 23:36:00 +0800
